/* SAM3XA WDT Header
   (c) S. Raase, 2015 */
#ifndef _DEVICES_WDT_H_
#define _DEVICES_WDT_H_

typedef struct {
	reg32_wo  WDT_CR;	/* Control Register */
	reg32_wo  WDT_MR;	/* Mode Register */
	reg32_ro  WDT_SR;	/* Status Register */
} regs_wdt;

/* Control Register */
#define WDT_CR_WDRSTT    (1 << 0)
#define WDT_CR_KEY(val)  (((val) << 24) & (0xFF << 24))

/* Mode Register */
#define WDT_MR_WDV(val)  (((val) << 0) & (0xFFF << 0))
#define WDT_MR_WDFIEN    (1 << 12)
#define WDT_MR_WDRSTEN   (1 << 13)
#define WDT_MR_WDRPROC   (1 << 14)
#define WDT_MR_WDDIS     (1 << 15)
#define WDT_MR_WDD(val)  (((val) << 16) & (0xFFF << 16))
#define WDT_MR_WDDBGHLT  (1 << 28)
#define WDT_MR_WDIDLEHLT (1 << 29)

/* Status Register */
#define WDT_SR_WDUNF     (1 << 0)
#define WDT_SR_WDERR     (1 << 1)

#endif /* _DEVICES_WDT_H_ */
